#
# Conditional build:
%bcond_without	perl	# without perl support
%bcond_without	ipv6	# without IPv6 support
%bcond_without	ssl	# without SSL  support
%bcond_without	dynamic	# without dynamic libraries
%bcond_without	xmpp	# without plugin

%define		no_install_post_check_so	1

%define		idea_ver	0.1.46
%define		xmpp_ver	0.52
%define		irssi_perl_version 20141011
%{?with_perl:%include	/usr/lib/rpm/macros.perl}
Summary:	Irssi is a IRC client
Summary(fr.UTF-8):	Irssi est un client IRC
Summary(hu.UTF-8):	Irssi egy IRC kliens
Summary(pl.UTF-8):	Irssi - wygodny w użyciu klient IRC
Name:		irssi
Version:	0.8.17
Release:	2
License:	GPL
Group:		Applications/Communications
#Source0:	http://www.irssi.org/files/snapshots/%{name}-%{_snap}.tar.gz
Source0:	http://www.irssi.org/files/%{name}-%{version}.tar.gz
# Source0-md5:	00cde2ba7ba37af9e3df451f430ecdea
Source1:	%{name}.desktop
Source2:	%{name}.png
# NXDOMAIN
#Source3:	http://real.irssi.org/files/plugins/idea/%{name}-idea-%{idea_ver}.tar.gz
Source3:	%{name}-idea-%{idea_ver}.tar.gz
# Source3-md5:	c326efe317b8f67593a3cd46d5557280
Source4:	http://cybione.org/~irssi-xmpp/files/irssi-xmpp-%{xmpp_ver}.tar.gz
# Source4-md5:	f48d66ddf6a6d8e4d04bfc44b83dc3c7
Patch0:		%{name}-dcc-send-limit.patch
Patch1:		%{name}-home_etc.patch
Patch2:		%{name}-idea-listlen.patch
Patch3:		%{name}-gcc4.patch
Patch4:		%{name}-dynamic.patch
Patch5:		%{name}-invalid_free.patch
Patch6:		%{name}-color_support_for_gui_entry.patch
Patch7:		%{name}-libs-nopoison.patch
Patch8:		am.patch
URL:		http://www.irssi.org/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	gettext-tools
# for idea only
BuildRequires:	glib-devel
BuildRequires:	glib2-devel >= 2.24.0
BuildRequires:	libtool
%{?with_xmpp:BuildRequires:	loudmouth-devel}
BuildRequires:	ncurses-devel >= 5.0
%{?with_ssl:BuildRequires:	openssl-devel >= 0.9.7d}
%{?with_perl:BuildRequires:	perl-devel >= 1:5.8.4}
BuildRequires:	pkgconfig
BuildRequires:	popt-devel
%{?with_perl:BuildRequires:	rpm-perlprov}
BuildRequires:	rpmbuild(macros) >= 1.315
BuildRequires:	sed >= 4.0
Requires:	glib2 >= 2.24.0
Provides:	perl(Irssi) = %{irssi_perl_version}
Obsoletes:	irssi-speech
Obsoletes:	irssi-sql
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%if %{with dynamic}
%define		filterout_ld	-Wl,--as-needed
%endif

%description
Irssi is a textUI IRC client with IPv6 support.

%description -l fr.UTF-8
Irssi est client IRC.

%description -l hu.UTF-8
Irssi egy szöveges felületű IRC kliens IPv6 támogatással.

%description -l pl.UTF-8
Irssi jest tekstowym klientem IRC ze wsparciem dla IPv6.

%package plugin-idea
Summary:	Irssi plugin IDEA crypt
Summary(hu.UTF-8):	Irssi IDEA plugin
Summary(pl.UTF-8):	Wtyczka do irssi do szyfrowania IDEA
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}
Requires:	glib >= 1:1.2.10-13

%description plugin-idea
This package contains IDEA Crypt plugin for Irssi.

%description plugin-idea -l hu.UTF-8
Ez a csomag tartalmazza az IDEA titkosítási plugint Irssi-hez.

%description plugin-idea -l pl.UTF-8
Ten pakiet zawiera wtyczkę do Irssi z szyfrowaniem IDEA.

%package plugin-xmpp
Summary:	Irssi XMPP support plugin
Summary(pl.UTF-8):	Wtyczka do irssi do obsługi XMPP
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}

%description plugin-xmpp
This package contains XMPP support plugin for Irssi.

%description plugin-xmpp -l pl.UTF-8
Ten pakiet zawiera wtyczkę do Irssi z obsługą XMPP.

%prep
%setup -q -a3 -a4
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%if %{with dynamic}
%patch4 -p1
%endif
%patch5 -p1
%patch6 -p0
%patch7 -p1

echo 'AC_DEFUN([AM_PATH_GLIB],[:])' > glib1.m4

mv irssi-idea{-%{idea_ver},}
mv irssi-xmpp{-%{xmpp_ver},}
%patch8 -p1

# hack
%{__sed} -i -e 's#\./libtool#%{_bindir}/libtool#g' 'configure.ac'

%build
ver=$(awk '/IRSSI_VERSION_DATE/{print $3}' irssi-version.h)
if [ "$ver" != "%{irssi_perl_version}" ]; then
	: update irssi_perl_version to $ver
	exit 1
fi

%{__libtoolize}
%{__aclocal} -I .
%{__autoconf}
%{__automake}
%configure \
	--without-socks \
	--with-bot \
	--with-textui \
	--with-proxy \
	--with-terminfo \
	--with-modules \
	%{?with_perl:--with-perl=yes} \
	%{?with_perl:--with-perl-lib=vendor} \
	%{!?with_perl:--with-perl=no} \
	%{?with_ipv6:--enable-ipv6} \
	--enable-true-color \
	--enable-nls \
	--%{?with_ssl:en}%{!?with_ssl:dis}able-ssl

%{__make}

# to fool idea configure script
touch irssi-config
cd irssi-idea
%{__libtoolize}
%{__aclocal} -I .
%{__autoconf}
%{__automake}
%configure
%{__make}

cd ..
export IRSSI_INCLUDE=`pwd`
cd irssi-xmpp
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_pixmapsdir},%{_desktopdir}}
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	docdir=%{_datadir}/%{name}-%{version}

# scripts packaged by irssi-scripts.spec
rm -f $RPM_BUILD_ROOT%{_datadir}/%{name}/scripts/*

cp -a %{SOURCE1} $RPM_BUILD_ROOT%{_desktopdir}
cp -a %{SOURCE2} $RPM_BUILD_ROOT%{_pixmapsdir}

%{__make} -C irssi-idea install \
	DESTDIR=$RPM_BUILD_ROOT

%{__make} -C irssi-xmpp install \
	PREFIX=%{_prefix} \
	IRSSI_LIB=%{_libdir}/%{name} \
	DESTDIR=$RPM_BUILD_ROOT

# -devel?
rm $RPM_BUILD_ROOT%{_libdir}/lib*.{so,la,a}
rm -r $RPM_BUILD_ROOT%{_includedir}/irssi
# cleanup
rm $RPM_BUILD_ROOT%{_libdir}/irssi/modules/lib*.{la,a}
%if %{with perl}
rm $RPM_BUILD_ROOT%{perl_archlib}/perllocal.pod
rm $RPM_BUILD_ROOT%{perl_vendorarch}/auto/Irssi/.packlist
rm $RPM_BUILD_ROOT%{perl_vendorarch}/auto/Irssi/Irc/.packlist
rm $RPM_BUILD_ROOT%{perl_vendorarch}/auto/Irssi/TextUI/.packlist
rm $RPM_BUILD_ROOT%{perl_vendorarch}/auto/Irssi/UI/.packlist
%endif
rm -r $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog README.md TODO NEWS docs/*.{txt,html}
%attr(755,root,root) %{_bindir}/botti
%attr(755,root,root) %{_bindir}/irssi
%dir %{_libdir}/irssi
%dir %{_libdir}/irssi/modules
%attr(755,root,root) %{_libdir}/irssi/modules/libirc_proxy.so*
%if %{with dynamic}
%attr(755,root,root) %{_libdir}/libirssi*.so.*
%endif
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/scripts
%{_datadir}/%{name}/help
%{_datadir}/%{name}/themes
%{_desktopdir}/irssi.desktop
%{_pixmapsdir}/irssi.png
%{_sysconfdir}/irssi.conf
%{_mandir}/man1/irssi.1*

%if %{with perl}
%{perl_vendorarch}/*.pm
%dir %{perl_vendorarch}/Irssi
%{perl_vendorarch}/Irssi/*.pm

%dir %{perl_vendorarch}/auto/Irssi
%attr(755,root,root) %{perl_vendorarch}/auto/Irssi/*.so

%dir %{perl_vendorarch}/auto/Irssi/Irc
%attr(755,root,root) %{perl_vendorarch}/auto/Irssi/Irc/*.so

%dir %{perl_vendorarch}/auto/Irssi/TextUI
%attr(755,root,root) %{perl_vendorarch}/auto/Irssi/TextUI/*.so

%dir %{perl_vendorarch}/auto/Irssi/UI
%attr(755,root,root) %{perl_vendorarch}/auto/Irssi/UI/*.so
%endif

%files plugin-idea
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/irssi/modules/libidea.so

%files plugin-xmpp
%defattr(644,root,root,755)
%doc irssi-xmpp/{docs/*,NEWS,README,TODO}
%attr(755,root,root) %{_libdir}/irssi/modules/libfe_xmpp.so
%attr(755,root,root) %{_libdir}/irssi/modules/libtext_xmpp.so
%attr(755,root,root) %{_libdir}/irssi/modules/libxmpp_core.so
%changelog
* Sun Mar 01 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/irssi.git;a=log;h=master

* Sun Mar 01 2015 Elan Ruusamäe <glen@delfi.ee> b1256ac
- x32 rebuild
- release 2 (by relup.sh)

* Sun Dec 28 2014 Jan Rękorajski <baggins@pld-linux.org> 2f9c6be
- updated gettext BR

* Thu Oct 23 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> c7d2e44
- up to 0.8.17

* Sat Sep 13 2014 Jan Rękorajski <baggins@pld-linux.org> b443568
- removed zero-sized bs files
- rel 2

* Sat May 31 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> e143292
- up to 0.8.16

* Sun Jun 09 2013 Jan Rękorajski <baggins@pld-linux.org> 4f1a737
- fix building with automake 1.13
- rel 13

* Sat Jun 08 2013 Jan Rękorajski <baggins@pld-linux.org> 88a6d82
- rebuild with perl 5.18.0
- release 12 (by relup.sh)

* Wed Mar 28 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 599d748
- release 11

* Sat Jan 21 2012 Jan Rękorajski <baggins@pld-linux.org> c1ae1e7
- added xmpp plugin

* Tue Jan 10 2012 lisu <lisu@pld-linux.org> 7de6b4c
- no more separated libtinfo(w)

* Tue Jan 03 2012 lisu <lisu@pld-linux.org> 65bb74a
- rel 9

* Wed Aug 31 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> d74202c
- release 8

* Sat Nov 20 2010 hawk <hawk@pld-linux.org> 531f827
- enabled no_install_post_check_so, too many libs to list them one by one

* Mon Nov 15 2010 shadzik <shadzik@pld-linux.org> 4f0eed9
- rel 6

* Sat Nov 13 2010 pawelz <pawelz@pld-linux.org> b76bf1c
- release 5

* Sat Jun 05 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> aab3842
- release 4

* Wed May 12 2010 sparky <sparky@pld-linux.org> b72c745
- readded BR: glib-devel

* Sat Apr 10 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 3a7e8ef
- release 3

* Tue Apr 06 2010 Zsolt Udvari <uzsolt@pld-linux.org> 9fc42c2
- glib2 >= 2.24.0 R and BR (irssi: symbol lookup error: /usr/lib/libirssife_common_core.so.0: undefined symbol: g_malloc0_n)
- remove glib-devel BR (doesn't support)
- rel 2

* Mon Apr 05 2010 pawelz <pawelz@pld-linux.org> 6400c7f
- I guess Hungarian language also uses dot to mark end of sentence.

